unit main;

interface
{$I 'qdac.inc'}
uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,qstring,qjson,system.Diagnostics;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    mmResult: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button9: TButton;
    Button13: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private declarations }
    procedure DoCopyIf(ASender,AItem:TQJson;var Accept:Boolean;ATag:Pointer);
    procedure DoDeleteIf(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer);
    procedure DoFindIf(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses typinfo;
{$R *.dfm}
type
  TRttiTestSubRecord=record
    Int64Val: Int64;
    UInt64Val: UInt64;
    UStr: String;
    AStr:AnsiString;
    SStr:ShortString;
    IntVal: Integer;
    MethodVal: TNotifyEvent;
    SetVal: TBorderIcons;
    WordVal: Word;
    ByteVal: Byte;
    ObjVal: TObject;
    DtValue: TDateTime;
    CardinalVal: Cardinal;
    ShortVal: Smallint;
    CurrVal: Currency;
    EnumVal: TAlign;
    CharVal: Char;
    VarVal:Variant;
    ArrayVal: TBytes;
  end;
  TRttiUnionRecord=record
    case Integer of
       0:(iVal:Integer);
       1:(bVal:Boolean);
    end;

  TRttiTestRecord=record
    Name:QStringW;
    Id:Integer;
    SubRecord:TRttiTestSubRecord;
    UnionRecord:TRttiUnionRecord;
  end;
  //Test for user
  TTitleRecord = packed record
    Title: TFileName;
    Date: TDateTime;
  end;

  TTitleRecords = packed record
    Len: Integer;
    TitleRecord: array[0..100] of TTitleRecord;
  end;





function GetFileSize(AFileName:String):Int64;
var
  sr:TSearchRec;
  AHandle:Integer;
begin
AHandle:=FindFirst(AFileName,faAnyFile,sr);
if AHandle=0 then
  begin
  Result:=sr.Size;
  FindClose(sr);
  end
else
  Result:=0;
end;
procedure TForm1.Button10Click(Sender: TObject);
var
  AJson,AItem:TQJson;
  S:String;
begin
AJson:=TQJson.Create;
try
  AJson.Add('Item1',0);
  AJson.Add('Item2',true);
  AJson.Add('Item3',1.23);
  for AItem in AJson do
    begin
    S:=S+AItem.Name+' => '+AItem.AsString+#13#10;
    end;
  mmResult.Lines.Add(S);
finally
  AJson.Free;
end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  AJson:TQJson;
begin
AJson:=TQJson.Create;
try
  //ǿ·ʣ·ڣᴴ··ָ./\֮һ
  AJson.ForcePath('demo1.item[0].name').AsString:='1';
  AJson.ForcePath('demo1.item[1].name').AsString:='100';
  try
    AJson.ForcePath('demo1[0].item[1]').AsString:='200';
  except
    //Ӧ׳쳣demo1Ƕ飬Ǵ
  end;
  //ʵ6Ԫأǰ5ԪػԶΪnull
  AJson.ForcePath('demo2[5]').AsInteger:=103;
  //ǿƴһȻAddӳԱ
  AJson.ForcePath('demo3[]').Add('Value',1.23);
  //Ĵ뽫"demo4":[{"Name":"demo4"}]Ľ
  AJson.ForcePath('demo4[].Name').AsString:='demo4';
  //ֱǿ·
  AJson.ForcePath('demo5[0]').AsString:='demo5';
  mmResult.Text:=AJson.AsJson;
finally
  AJson.Free;
end;
end;

procedure TForm1.Button12Click(Sender: TObject);
var
  AJson:TQJson;
begin
AJson:=TQJson.Create;
try
  AJson.Parse(
    '{'+
    '"object":{'+
    ' "name":"object_1",'+
    ' "subobj":{'+
    '   "name":"subobj_1"'+
    '   },'+
    ' "subarray":[1,3,4]'+
    ' },'+
    '"array":[100,200,300,{"name":"object"}]'+
    '}');
  mmResult.Lines.Add('ItemByPath(''object\subobj\name'')='+AJson.ItemByPath('object\subobj\name').AsString);
  mmResult.Lines.Add('ItemByPath(''object\subarray[1]'')='+AJson.ItemByPath('object\subarray[1]').AsString);
  mmResult.Lines.Add('ItemByPath(''array[1]'')='+AJson.ItemByPath('array[1]').AsString);
  mmResult.Lines.Add('ItemByPath(''array[3].name'')='+AJson.ItemByPath('array[3].name').AsString);
finally
  AJson.Free;
end;
end;

procedure TForm1.Button13Click(Sender: TObject);
var
  AJson,AItem: TQJson;
  i: Integer;
  TitleRecords: TTitleRecords;
begin
TitleRecords.Len := 2;
TitleRecords.TitleRecord[0].Title := '1';
TitleRecords.TitleRecord[0].Date := Now;
TitleRecords.TitleRecord[1].Title := '2';
TitleRecords.TitleRecord[1].Date := Now;
AJson := TQJson.Create;
AItem:=AJson.Add('TitleRecords');
AItem.Add('Len', TitleRecords.Len);
with AItem.Add('TitleRecord',jdtArray) do
  begin
  for i := 0 to TitleRecords.Len - 1 do
    AddRecord('', TitleRecords.TitleRecord[i])
  end;
ShowMessage(AJson.AsJson);
AJson.Free;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  AJson:TQJson;
  I:Integer;
  T:Cardinal;
begin
AJson:=TQJson.Create;
try
  T:=GetTickCount;
  for I := 0 to 100000 do
    AJson.Add('_'+IntToStr(I),Now);
  T:=GetTickCount-T;
  mmResult.Clear;
  mmResult.Lines.Add('100,000ʱ:'+IntToStr(T)+'ms');
finally
  AJson.Free;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  AJson:TQJson;
  TestRecord:TRttiTestRecord;
begin
AJson:=TQJson.Create;
try
  TestRecord.Id:=10001;
  TestRecord.Name:='Complex Record';
  TestRecord.UnionRecord.iVal:=100;
  TestRecord.SubRecord.Int64Val:=1;
  TestRecord.SubRecord.UInt64Val:=2;
  TestRecord.SubRecord.UStr:='Test String';
  TestRecord.SubRecord.IntVal:=3;
  TestRecord.SubRecord.MethodVal:=Button2Click;
  TestRecord.SubRecord.SetVal:=[TBorderIcon.biSystemMenu];
  TestRecord.SubRecord.WordVal:=4;
  TestRecord.SubRecord.ByteVal:=5;
  TestRecord.SubRecord.ObjVal:=Button2;
  TestRecord.SubRecord.DtValue:=Now;
  TestRecord.SubRecord.CardinalVal:=6;
  TestRecord.SubRecord.ShortVal:=7;
  TestRecord.SubRecord.CurrVal:=8.9;
  TestRecord.SubRecord.EnumVal:=TAlign.alTop;
  TestRecord.SubRecord.CharVal:='A';
  TestRecord.SubRecord.VarVal:=VarArrayOf(['VariantArray',1,2.5,true,false]);
  SetLength(TestRecord.SubRecord.ArrayVal,3);
  TestRecord.SubRecord.ArrayVal[0]:=100;
  TestRecord.SubRecord.ArrayVal[1]:=101;
  TestRecord.SubRecord.ArrayVal[2]:=102;
  with AJson.Add('FixedTypes') do
    begin
    AddDateTime('DateTime',Now);
    Add('Integer',1000);
    Add('Boolean',True);
    Add('Float',1.23);
    Add('Array',[1,'goods',true,3.4]);
    AddObject('RTTIObject',Button2,nil,false,nil);
//    AddRecord('RTTIRecord',TestRecord);
    end;
  with AJson.Add('AutoTypes') do
    begin
    Add('Integer','-100');
    Add('Float','-12.3');
    Add('Array','[2,''goods'',true,4.5]');
    Add('Object','{"Name":"Object_Name","Value":"Object_Value"}');
    Add('ForceArrayAsString','[2,''goods'',true,4.5]',jdtString);
    Add('ForceObjectAsString','{"Name":"Object_Name","Value":"Object_Value"}',jdtString);
    end;
  with AJson.Add('AsTypes') do
    begin
    Add('Integer').AsInteger:=123;
    Add('Float').AsFloat:=5.6;
    Add('Boolean').AsBoolean:=False;
    Add('VarArray').AsVariant:=VarArrayOf([9,10,11,2]);
    Add('Array').AsArray:='[10,3,22,99]';
    Add('Object').AsObject:='{"Name":"Object_2","Value":"Value_2"}';
    end;
  mmResult.Clear;
  mmResult.Lines.Add('ӲԽ:');
  mmResult.Lines.Add(AJson.Encode(True));
finally
  AJson.Free;
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  AJson:TQJson;
  T:Cardinal;
  Speed:Cardinal;
  procedure PreCache;
  var
    AStream:TMemoryStream;
  begin
  AStream:=TMemoryStream.Create;
  try
    AStream.LoadFromFile(OpenDialog1.FileName);
  finally
    AStream.Free;
  end;
  end;
begin
if OpenDialog1.Execute then
  begin
//  uJsonTest;
  AJson:=TQJson.Create;
  try
    T:=GetTickCount;
    AJson.LoadFromFile(OpenDialog1.FileName,teUtf8);
    T:=GetTickCount-T;
    if T>0 then
      Speed:=(GetFileSize(OpenDialog1.FileName)*1000 div T)
    else
      Speed:=0;
    mmResult.Clear;
//    mmResult.Lines.Add('صJSONļݣ');
//    mmResult.Lines.Add(AJson.Encode(True));
    mmResult.Lines.Add('QJsonʱ:'+IntToStr(T)+'msٶ:'+RollupSize(Speed));
  finally
    AJson.Free;
  end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  AJson:TQJson;
  I:Integer;
  T1,T2:Cardinal;
  Speed:Cardinal;
begin
if SaveDialog1.Execute then
  begin
  AJson:=TQJson.Create;
  try
    mmResult.Clear;
    T1:=GetTickCount;
    with AJson.Add('Integers',jdtObject) do
      begin
      for I := 0 to 1000000 do
        Add('Node'+IntToStr(I)).AsInteger :=I;
      end;
    T1:=GetTickCount-T1;
    T2:=GetTickCount;
    AJson.SaveToFile(SaveDialog1.FileName,teAnsi,false);
    T2:=GetTickCount-T2;
    if T2>0 then
      Speed:=(GetFileSize(SaveDialog1.FileName)*1000 div T2)
    else
      Speed:=0;
    mmResult.Lines.Add('10ʱ'+IntToStr(T1)+'ms,ʱ:'+IntToStr(T2)+'msٶȣ'+RollupSize(Speed));
  finally
    AJson.Free;
  end;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  AJson:TQJson;
begin
AJson:=TQJson.Create;
try
  AJson.Parse('{"results":[],"status":102,"msg":"IP\/SN\/SCODE\/REFERER Illegal:"}');
//  '{"name":"object_0","Id":1}');
  ShowMessage(AJson.Encode(True));
finally
  AJson.Free;
end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  ARec:TRttiTestSubRecord;
  AJson,ACopy:TQJson;
begin
  ARec.Int64Val:=1;
  ARec.UInt64Val:=2;
  ARec.UStr:='Test String';
  ARec.AStr:='AnsiString';
  ARec.SStr:='ShortString';
  ARec.IntVal:=3;
  ARec.MethodVal:=Button2Click;
  ARec.SetVal:=[TBorderIcon.biSystemMenu];
  ARec.WordVal:=4;
  ARec.ByteVal:=5;
  ARec.ObjVal:=Button2;
  ARec.DtValue:=Now;
  ARec.CardinalVal:=6;
  ARec.ShortVal:=7;
  ARec.CurrVal:=8.9;
  ARec.EnumVal:=TAlign.alTop;
  ARec.CharVal:='A';
  ARec.VarVal:=VarArrayOf(['VariantArray',1,2.5,true,false]);
  SetLength(ARec.ArrayVal,3);
  ARec.ArrayVal[0]:=100;
  ARec.ArrayVal[1]:=101;
  ARec.ArrayVal[2]:=102;
  AJson:=TQJson.Create;
  try
    AJson.AddRecord('Record',ARec);
    ACopy:=AJson.ItemByName('Record').Copy;
    ACopy.ItemByName('Int64Val').AsInt64:=100;
    ACopy.ItemByPath('UStr').AsString:='UnicodeString-ByJson';
    ACopy.ItemByPath('AStr').AsString:='AnsiString-ByJson';
    ACopy.ItemByPath('SStr').AsString:='ShortString-ByJson';
    ACopy.ItemByPath('EnumVal').AsString:='alBottom';
    ACopy.ItemByPath('SetVal').AsString:='[biHelp]';
    ACopy.ItemByPath('ArrayVal').AsJson:='[10,30,15]';
    ACopy.ItemByPath('VarVal').AsVariant:=VarArrayOf(['By Json',3,4,false,true]);
    ACopy.ToRecord(ARec);
    ACopy.Free;
    AJson.AddRecord('NewRecord',ARec);
    mmResult.Lines.Add(AJson.AsJson);
  finally
    AJson.Free;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  AStream:TMemoryStream;
  AJson:TQJson;
  S:QStringW;
  AEncode:TTextEncoding;
begin
AStream:=TMemoryStream.Create;
AJson:=TQJson.Create;
try
  AJson.DataType:=jdtObject;
  S:='{"record1":{"id":100,"name":"name1"}}'#13#10+
    '{"record2":{"id":200,"name":"name2"}}'#13#10+
    '{"record3":{"id":300,"name":"name3"}}'#13#10;
  //UCS2
  mmResult.Lines.Add('Unicode 16 LE:');
  AEncode:=teUnicode16LE;
  AStream.Size:=0;
  SaveTextW(AStream,S,False);
  AStream.Position:=0;
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add('һν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ڶν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ν:');
  mmResult.Lines.Add(AJson.AsJson);
  //UTF-8
  mmResult.Lines.Add('UTF8:');
  AEncode:=teUtf8;
  AStream.Size:=0;
  SaveTextU(AStream,qstring.Utf8Encode(S),False);
  AStream.Position:=0;
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'һν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ڶν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ν:');
  mmResult.Lines.Add(AJson.AsJson);
  //ANSI
  mmResult.Lines.Add(#13#10'ANSI:');
  AEncode:=teAnsi;
  AStream.Size:=0;
  SaveTextA(AStream,qstring.AnsiEncode(S));
  AStream.Position:=0;
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add('һν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ڶν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ν:');
  mmResult.Lines.Add(AJson.AsJson);
  //UCS2BE
  mmResult.Lines.Add(#13#10'Unicode16BE:');
  AEncode:=teUnicode16BE;
  AStream.Size:=0;
  SaveTextWBE(AStream,S,False);
  AStream.Position:=0;
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add('һν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ڶν:'#13#10);
  mmResult.Lines.Add(AJson.AsJson);
  AJson.Clear;
  AJson.ParseBlock(AStream,AEncode);
  mmResult.Lines.Add(#13#10'ν:');
  mmResult.Lines.Add(AJson.AsJson);
finally
  AStream.Free;
  AJson.Free;
end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  AJson,AItem:TQJson;
  I:Integer;
  DynArray:array of Integer;
  RecordArray:array of TRttiUnionRecord;
begin
AJson:=TQJson.Create;
try
  //ԪصNַʽʾ
  // 1. ֱӵAddԪıķʽ
  AJson.Add('AddArrayText','["Item1",100,null,true,false,123.4]',jdtArray);//jdtArrayʡԻԶԣȷ֪ͲҪжӿ
  // 2. ֱ
  AJson.Add('AddArray',['Item1',100,Null,True,False,123.4]);
  // 3. ֱVarArrayOfֵ
  AJson.Add('AsVariant').AsVariant:=VarArrayOf(['Item1',100,Null,True,False,123.4]);
  //ڶ̬飬
  SetLength(DynArray,5);
  DynArray[0]:=100;
  DynArray[1]:=200;
  DynArray[2]:=300;
  DynArray[3]:=400;
  DynArray[4]:=500;
  AJson.Add('DynArray').AsVariant:=DynArray;
  SetLength(RecordArray,2);
  RecordArray[0].iVal:=1;
  RecordArray[1].iVal:=2;
  with AJson.Add('RecordArray',jdtArray) do
    begin
    for I := 0 to High(RecordArray) do
      AddRecord('',RecordArray[I]);
    end;
//  AJson.Add('RecordArray').AsVariant:=RecordArray;
// 4. ֱAsArrayļ
  AJson.Add('AsArray').AsArray:='["Item1",100,null,true,false,123.4]';
  // 5. ֶԪ
  with AJson.Add('Manul') do
    begin
    DataType:=jdtArray;
    Add.AsString:='Item1';
    Add.AsInteger:=100;
    Add;
    Add.AsBoolean:=True;
    Add.AsBoolean:=False;
    Add.AsFloat:=123.4;
    end;
  // Ӷֻͣӽ㻻ǶͿ
  AJson.Add('Object',[TQJson.Create.Add('Item1',100).Parent,TQJson.Create.Add('Item2',true).Parent]);
  mmResult.Lines.Add(AJson.AsJson);
  //еԪ
  mmResult.Lines.Add('ʹfor inöManulԪֵ');
  I:=0;
  for AItem in AJson.ItemByName('Manul') do
     begin
     mmResult.Lines.Add('Manul['+IntToStr(I)+']='+AItem.AsString);
     Inc(I);
     end;
  mmResult.Lines.Add('ʹͨforѭöManulԪֵ');
  AItem:=AJson.ItemByName('Manul');
  for I := 0 to AItem.Count-1 do
     mmResult.Lines.Add('Manul['+IntToStr(I)+']='+AItem[I].AsString);
finally
  FreeObject(AJson);
end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  AJson,AItem:TQJson;
  I:Integer;
begin
AJson:=TQJson.Create;
try
  AJson.Parse('{'+
    '"object":{'+
    ' "name":"object_1",'+
    ' "subobj":{'+
    '   "name":"subobj_1"'+
    '   },'+
    ' "subarray":[1,3,4]'+
    ' },'+
    '"array":[100,200,300,{"name":"object"}]'+
    '}');
  {$IFDEF QDAC_RTTI}
  AItem:=AJson.CopyIf(nil,procedure(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer)
    begin
    Accept:=(AChild.DataType<>jdtArray);
    end);
  {$ELSE}
  AItem:=AJson.CopyIf(nil,DoCopyIf);
  {$ENDIF}
  mmResult.Lines.Add('CopyIfƳн');
  mmResult.Lines.Add(AItem.AsJson);
  mmResult.Lines.Add('FindIfָĽ');
  {$IFDEF QDAC_RTTI}
  mmResult.Lines.Add(AItem.FindIf(nil,true,procedure(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer)
    begin
    Accept:=(AChild.Name='subobj');
    end).AsJson);
  {$ELSE}
  mmResult.Lines.Add(AItem.FindIf(nil,true,DoFindIf);
  {$ENDIF}
  mmResult.Lines.Add('ɾеsubobj');
  {$IFDEF QDAC_RTTI}
  AItem.DeleteIf(nil,true,procedure(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer)
    begin
    Accept:=(AChild.Name='subobj');
    end);
  {$ELSE}
  AItem.DeleteIf(nil,true,DoDeleteIf);
  {$ENDIF}
  mmResult.Lines.Add(AItem.AsJson);
finally
  FreeObject(AItem);
  FreeObject(AJson);
end;
end;

procedure TForm1.DoCopyIf(ASender, AItem: TQJson; var Accept: Boolean;
  ATag: Pointer);
begin
Accept:=(AItem.DataType<>jdtArray);
end;
procedure TForm1.DoDeleteIf(ASender,AChild:TQJson;var Accept:Boolean;ATag:Pointer);
begin
Accept:=(AChild.Name='subobj');
end;

procedure TForm1.DoFindIf(ASender, AChild: TQJson; var Accept: Boolean;
  ATag: Pointer);
begin
Accept:=(AChild.Name='subobj');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ReportMemoryLeaksOnShutdown:=True;
end;

end.
